#ifndef s11n_SQLITE3_S11NLITE_API_HPP_INCLUDED
#define s11n_SQLITE3_S11NLITE_API_HPP_INCLUDED 1

#include <sqlite3.h>

#include <s11n.net/s11n/s11nlite.hpp> // client_api interface

namespace s11n { namespace io {
namespace sqlite3 {

	/**
	   A class for use with s11nlite::instance(). The variants of
	   load()/save() taking string parameters (filenames) de/serialize
	   to/from sqlite3 databases. Stream-based de/ser uses the default
	   s11nlite behaviour.

	*/
	class s11nlite_api : public ::s11nlite::client_interface
	{
	public:
		s11nlite_api();
		virtual ~s11nlite_api();
		/**
		   See sqlite3_serializer::serialize(src,dest).
		*/
		virtual bool save( const node_type & src, const std::string & dest );
		/**
		   See sqlite3_serializer::deserialize(src).
		*/
		virtual node_type * load_node( const std::string & src );
		/**
		   See sqlite3_serializer::serialize(src,dest).
		*/
		virtual bool save( const node_type & src, std::ostream & dest );
		/**
		   See sqlite3_serializer::deserialize(src).
		*/
		virtual node_type * load_node( std::istream & src );
	};



} } } // namespace s11n::io::sqlite3



#endif // s11n_SQLITE3_S11NLITE_API_HPP_INCLUDED
