
#include <s11n.net/s11n/s11n_node.hpp>
#include <s11n.net/s11n/io/sqlite3/sqlite3_serializer.hpp>
#include <s11n.net/s11n/io/serializers.hpp> // register_serializer()

namespace {

	/**
		Register sqlite3_serializer with the s11nlite
		Serializer classloader.
	*/
        void sqlite3_serializer_registration_init()
        {

		std::string sqlcookie(s11n_SQLITE_MAGIC_COOKIE_SQL);
		std::string classname( "s11n::io::sqlite3::sqlite3_serializer" );
		std::string shortname("sqlite3");

#define SERINST(NodeT)                                  \
                ::s11n::io::register_serializer< ::s11n::io::sqlite3::sqlite3_serializer< NodeT > >( classname, shortname ); \
                ::s11n::cl::classloader_alias< ::s11n::io::data_node_serializer< NodeT > >( sqlcookie, classname );

                SERINST(s11n::s11n_node);
#undef SERINST
        }

        const int sqlite3_reg_placeholder = 
                ( sqlite3_serializer_registration_init(), 1 );



} // anonymous namespace
